        import java.awt.*;
        import java.awt.event.*;
        import java.applet.Applet;

    public class spinner extends Applet implements ActionListener, Runnable {

        Image spinImages[] = new Image[4];
        Image nowImage; 
        int spinIndex = 0;
        Thread spinThread;
        Button suspendButton, resumeButton;
        boolean animateFlag = true;
        boolean goFlag = true;

        public void init() {
                spinImages[0] = getImage(getCodeBase(), "spin1.gif");
                spinImages[1] = getImage(getCodeBase(), "spin2.gif");
                spinImages[2] = getImage(getCodeBase(), "spin3.gif");
                spinImages[3] = getImage(getCodeBase(), "spin4.gif");
                suspendButton = new Button("Suspend");
                add(suspendButton); 
                suspendButton.addActionListener(this);
                resumeButton = new Button("Resume");
                add(resumeButton); 
                resumeButton.addActionListener(this);
        }

        public synchronized void actionPerformed(ActionEvent e){
             if(e.getSource() == suspendButton){
                 goFlag = false; 
             }
             if(e.getSource() == resumeButton){
                 goFlag = true; 
                 notify();
             }
        }

        public void start() {
            spinThread = new Thread(this);
            spinThread.start();
        }

        public void stop() {
            animateFlag = false;
        }

        public void run() {
                while(animateFlag){
                        nowImage = spinImages[spinIndex++];
                        if(spinIndex > 3)spinIndex = 0;
                        repaint();
                        try {
                            Thread.sleep(200);
                            synchronized(this){
                                while(!goFlag)
                                    wait();
                            }
                        }
                        catch(InterruptedException e) { }
                }
        }

        public void paint (Graphics g) {
                if(nowImage != null) g.drawImage(nowImage, 100, 100, this);
        }

        public void update(Graphics g) {
                g.clipRect(100, 100, 200, 200);
                paint(g);
        }
   }
